/**
* DevExtreme (ui/file_manager/file_provider/remote.d.ts)
* Version: 19.2.5 (build 19365-1131)
* Build date: Tue Dec 31 2019
*
* Copyright (c) 2012 - 2019 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import FileProvider, {
    FileProviderOptions
} from './file_provider';

/** Warning! Do not import this directly */
export interface RemoteFileProviderOptions extends FileProviderOptions<RemoteFileProvider> {
    /**
     * @docid RemoteFileProviderOptions.endpointUrl
     * @type string
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    endpointUrl?: string;
    /**
     * @docid RemoteFileProviderOptions.hasSubDirectoriesExpr
     * @type string|function(fileItem)
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    hasSubDirectoriesExpr?: string | Function;
}
/** The Remote file provider works with a file system located on the server. */
export default class RemoteFileProvider extends FileProvider {
    constructor(options?: RemoteFileProviderOptions)
}
