/**
* DevExtreme (ui/load_indicator.d.ts)
* Version: 19.2.5 (build 19365-1131)
* Build date: Tue Dec 31 2019
*
* Copyright (c) 2012 - 2019 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/** Warning! Do not import this directly */
export interface dxLoadIndicatorOptions extends WidgetOptions<dxLoadIndicator> {
    /**
     * @docid dxLoadIndicatorOptions.indicatorSrc
     * @type string
     * @default ""
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    indicatorSrc?: string;
}
/** The LoadIndicator is a UI element notifying the viewer that a process is in progress. */
export default class dxLoadIndicator extends Widget {
    constructor(element: Element, options?: dxLoadIndicatorOptions)
    constructor(element: JQuery, options?: dxLoadIndicatorOptions)
}

declare global {
interface JQuery {
    dxLoadIndicator(): JQuery;
    dxLoadIndicator(options: "instance"): dxLoadIndicator;
    dxLoadIndicator(options: string): any;
    dxLoadIndicator(options: string, ...params: any[]): any;
    dxLoadIndicator(options: dxLoadIndicatorOptions): JQuery;
}
}
/** Warning! Do not import this directly */
export type Options = dxLoadIndicatorOptions;

/** @deprecated use Options instead */
/** Warning! Do not import this directly */
export type IOptions = dxLoadIndicatorOptions;