/**
* DevExtreme (ui/nav_bar.d.ts)
* Version: 19.2.5 (build 19365-1131)
* Build date: Tue Dec 31 2019
*
* Copyright (c) 2012 - 2019 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import dxTabs, {
    dxTabsItem,
    dxTabsOptions
} from './tabs';

/** Warning! Do not import this directly */
export interface dxNavBarOptions extends dxTabsOptions<dxNavBar> {
    /**
     * @docid dxNavBarOptions.scrollByContent
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    scrollByContent?: boolean;
}
/** The NavBar is a widget that navigates the application views. */
export default class dxNavBar extends dxTabs {
    constructor(element: Element, options?: dxNavBarOptions)
    constructor(element: JQuery, options?: dxNavBarOptions)
}

/** Warning! Do not import this directly */
export interface dxNavBarItem extends dxTabsItem {
    /**
     * @docid dxNavBarItem.badge
     * @type String
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    badge?: string;
}

declare global {
interface JQuery {
    dxNavBar(): JQuery;
    dxNavBar(options: "instance"): dxNavBar;
    dxNavBar(options: string): any;
    dxNavBar(options: string, ...params: any[]): any;
    dxNavBar(options: dxNavBarOptions): JQuery;
}
}
/** Warning! Do not import this directly */
export type Options = dxNavBarOptions;

/** @deprecated use Options instead */
/** Warning! Do not import this directly */
export type IOptions = dxNavBarOptions;