/**
* DevExtreme (ui/recurrence_editor.d.ts)
* Version: 19.2.5 (build 19365-1131)
* Build date: Tue Dec 31 2019
*
* Copyright (c) 2012 - 2019 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import Editor, {
    EditorOptions
} from './editor/editor';

/** Warning! Do not import this directly */
export interface dxRecurrenceEditorOptions extends EditorOptions<dxRecurrenceEditor> {
    /**
     * @docid dxRecurrenceEditorOptions.value
     * @type string
     * @default null
     * @fires dxRecurrenceEditorOptions.onValueChanged
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    value?: string;
}
/** A base class for editors. */
export default class dxRecurrenceEditor extends Editor {
    constructor(element: Element, options?: dxRecurrenceEditorOptions)
    constructor(element: JQuery, options?: dxRecurrenceEditorOptions)
}

declare global {
interface JQuery {
    dxRecurrenceEditor(): JQuery;
    dxRecurrenceEditor(options: "instance"): dxRecurrenceEditor;
    dxRecurrenceEditor(options: string): any;
    dxRecurrenceEditor(options: string, ...params: any[]): any;
    dxRecurrenceEditor(options: dxRecurrenceEditorOptions): JQuery;
}
}
/** Warning! Do not import this directly */
export type Options = dxRecurrenceEditorOptions;

/** @deprecated use Options instead */
/** Warning! Do not import this directly */
export type IOptions = dxRecurrenceEditorOptions;