/**
* DevExtreme (ui/switch.d.ts)
* Version: 19.2.5 (build 19365-1131)
* Build date: Tue Dec 31 2019
*
* Copyright (c) 2012 - 2019 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import Editor, {
    EditorOptions
} from './editor/editor';

/** Warning! Do not import this directly */
export interface dxSwitchOptions extends EditorOptions<dxSwitch> {
    /**
     * @docid dxSwitchOptions.activeStateEnabled
     * @type boolean
     * @default true
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    activeStateEnabled?: boolean;
    /**
     * @docid dxSwitchOptions.focusStateEnabled
     * @type boolean
     * @default true [for](desktop)
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    focusStateEnabled?: boolean;
    /**
     * @docid dxSwitchOptions.hoverStateEnabled
     * @type boolean
     * @default true
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    hoverStateEnabled?: boolean;
    /**
     * @docid dxSwitchOptions.name
     * @type string
     * @hidden false
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    name?: string;
    /**
     * @docid dxSwitchOptions.offText
     * @type string
     * @deprecated dxSwitchOptions.switchedOffText
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    offText?: string;
    /**
     * @docid dxSwitchOptions.onText
     * @type string
     * @deprecated dxSwitchOptions.switchedOnText
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    onText?: string;
    /**
     * @docid dxSwitchOptions.switchedOffText
     * @type string
     * @default "OFF"
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    switchedOffText?: string;
    /**
     * @docid dxSwitchOptions.switchedOnText
     * @type string
     * @default "ON"
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    switchedOnText?: string;
    /**
     * @docid dxSwitchOptions.value
     * @type boolean
     * @default false
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    value?: boolean;
}
/** The Switch is a widget that can be in two states: "On" and "Off". */
export default class dxSwitch extends Editor {
    constructor(element: Element, options?: dxSwitchOptions)
    constructor(element: JQuery, options?: dxSwitchOptions)
}

declare global {
interface JQuery {
    dxSwitch(): JQuery;
    dxSwitch(options: "instance"): dxSwitch;
    dxSwitch(options: string): any;
    dxSwitch(options: string, ...params: any[]): any;
    dxSwitch(options: dxSwitchOptions): JQuery;
}
}
/** Warning! Do not import this directly */
export type Options = dxSwitchOptions;

/** @deprecated use Options instead */
/** Warning! Do not import this directly */
export type IOptions = dxSwitchOptions;