/**
* DevExtreme (ui/text_area.d.ts)
* Version: 19.2.5 (build 19365-1131)
* Build date: Tue Dec 31 2019
*
* Copyright (c) 2012 - 2019 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import dxTextBox, {
    dxTextBoxOptions
} from './text_box';

/** Warning! Do not import this directly */
export interface dxTextAreaOptions extends dxTextBoxOptions<dxTextArea> {
    /**
     * @docid dxTextAreaOptions.autoResizeEnabled
     * @type boolean
     * @default false
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    autoResizeEnabled?: boolean;
    /**
     * @docid dxTextAreaOptions.maxHeight
     * @type numeric|string
     * @default undefined
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    maxHeight?: number | string;
    /**
     * @docid dxTextAreaOptions.minHeight
     * @type numeric|string
     * @default undefined
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    minHeight?: number | string;
    /**
     * @docid dxTextAreaOptions.spellcheck
     * @type boolean
     * @default true
     * @prevFileNamespace DevExpress.ui
     * @public
     */
    spellcheck?: boolean;
}
/** The TextArea is a widget that enables a user to enter and edit a multi-line text. */
export default class dxTextArea extends dxTextBox {
    constructor(element: Element, options?: dxTextAreaOptions)
    constructor(element: JQuery, options?: dxTextAreaOptions)
}

declare global {
interface JQuery {
    dxTextArea(): JQuery;
    dxTextArea(options: "instance"): dxTextArea;
    dxTextArea(options: string): any;
    dxTextArea(options: string, ...params: any[]): any;
    dxTextArea(options: dxTextAreaOptions): JQuery;
}
}
/** Warning! Do not import this directly */
export type Options = dxTextAreaOptions;

/** @deprecated use Options instead */
/** Warning! Do not import this directly */
export type IOptions = dxTextAreaOptions;