/**
* DevExtreme (viz/vector_map/projection.d.ts)
* Version: 19.2.5 (build 19365-1131)
* Build date: Tue Dec 31 2019
*
* Copyright (c) 2012 - 2019 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
/** Warning! Do not import this directly */
export interface VectorMapProjectionConfig {
    /**
     * @docid VectorMapProjectionConfig.aspectRatio
     * @type number
     * @default 1
     * @prevFileNamespace DevExpress.viz
     * @public
     */
    aspectRatio?: number;
    /**
     * @docid VectorMapProjectionConfig.from
     * @type function
     * @type_function_param1 coordinates:Array<number>
     * @type_function_return Array<number>
     * @prevFileNamespace DevExpress.viz
     * @public
     */
    from?: ((coordinates: Array<number>) => Array<number>);
    /**
     * @docid VectorMapProjectionConfig.to
     * @type function
     * @type_function_param1 coordinates:Array<number>
     * @type_function_return Array<number>
     * @prevFileNamespace DevExpress.viz
     * @public
     */
    to?: ((coordinates: Array<number>) => Array<number>);
}


/** Warning! Do not import this directly */
/** Creates a new projection. */
export function projection(data: VectorMapProjectionConfig): any;

/** Adds a new projection to the internal projection storage. */
export function add(name: string, projection: VectorMapProjectionConfig | any): void;

/** Warning! Do not import this directly */
/** Gets a predefined or custom projection from the projection storage. */
export function get(name: 'equirectangular' | 'lambert' | 'mercator' | 'miller' | string): any;
